/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: start.S 451 2007-08-03 11:32:33Z honda $
 */

/*
 *  ͥбΥȥåץ⥸塼Nios2ѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */
#include "kernel_impl.h"

/*
 *  ꥻåȥ롼
 */
	.section .entry, "xa"
	.align 2
	.global __reset
__reset:
	/*
	 *  Iåν
	 */
#if NIOS2_ICACHE_SIZE > 0
#if NIOS2_ICACHE_SIZE > 0x8000
	movhi r2, %hi(NIOS2_ICACHE_SIZE)
#else 
	movui r2, NIOS2_ICACHE_SIZE
#endif
0:
	initi r2
	addi r2, r2, -NIOS2_ICACHE_LINE_SIZE
	bgt r2, zero, 0b
1:
	.pushsection .debug_alt_sim_info
	.int 1, 1, 0b, 1b
	.popsection
#endif /* NIOS2_ICACHE_SIZE > 0 */

	/*
	 *  startإ
	 */
	movhi r3, %hiadj(start)
	addi r3, r3, %lo(start)
	jmp r3


	.section .text
	.align 2
	.global start
	.type start, @function
start:
	/*
	 *  Dåν
	 */
#if NIOS2_DCACHE_SIZE > 0
#if NIOS2_DCACHE_SIZE > 0x8000
	movhi r2, %hi(NIOS2_DCACHE_SIZE)
#else
	movui r2, NIOS2_DCACHE_SIZE
#endif
0:
	initd 0(r2)
	addi r2, r2, -NIOS2_DCACHE_LINE_SIZE
	bgt r2, zero, 0b
1:
	.pushsection .debug_alt_sim_info
	.int 2, 1, 0b, 1b
	.popsection
#endif /* NIOS2_DCACHE_SIZE > 0 */

	/*
	 *  STATUS쥸νʳ߶ػߡ
	 */
	rdctl r3, status
	andi  r3, r3, STATUS_PIE
	wrctl status, r3

	/* 
	 *  Хݥ󥿡Υå
	 */
	movhi gp, %hiadj(_gp)
	addi  gp, gp, %lo(_gp)

	/*
	 *  åν
	 */
	ldw   sp, %gprel(_kernel_istkpt)(gp)

	/*
	 *  hardware_init_hook ƤӽФ(0Ǥʤ)
	 *
	 *  ϡɥ¸ɬפʽϡ
	 *  hardware_init_hook ȤؿѰդФ褤
	 *  ŪˤROMκݡRAMѲǽˤ뤿
	 *  ХȥνԤ
	 *  sys_support.S  _hardware_init_hook Ƥ
	 *  롥
	 */
start_0:
	movhi r2, %hiadj(_hardware_init_hook)
	addi  r2, r2, %lo(_hardware_init_hook)
	beq   zero, r2, start_1
	callr r2

	/*
	 *  bss򥯥ꥢ
	 */
start_1:
	movhi r3, %hiadj(__bss_start)
	addi  r3, r3, %lo(__bss_start)
	movhi r2, %hiadj(__bss_end)
	addi  r2, r2, %lo(__bss_end)
	beq   r3, r2, start_3
start_2:
	stw  zero, (r3)
	addi r3, r3, 4
	bltu r3, r2, start_2

	/*
	 *  dataνROMб
	 *
	 *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *  ԡ롥
	 */
start_3:
#ifndef NIOS2_OMIT_DATA_INIT
	movhi r3, %hiadj(__idata_start)
	addi  r3, r3, %lo(__idata_start)
	movhi r4, %hiadj(__idata_end)
	addi  r4, r4, %lo(__idata_end)
	beq   r3, r4, start_5  /* 0ʤ鲿⤷ʤ */
	movhi r6, %hiadj(__data_start)
	addi  r6, r6, %lo(__data_start)
start_4:
	ldw   r2, 0(r3)
	stw   r2, 0(r6)
	addi  r3, r3, 4
	addi  r6, r6, 4
	bltu  r3, r4, start_4
#endif /* NIOS2_OMIT_DATA_INIT */

	/*
	 *  software_init_hook ƤӽФ0 Ǥʤˡ
	 *
	 *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *  ϡsoftware_init_hook ȤؿѰդ
	 *  褤
	 */
start_5:
	movhi r2, %hiadj(_software_init_hook)
	addi  r2, r2, %lo(_software_init_hook)
	beq   zero, r2, start_6
	callr r2

start_6:
	call  sta_ker
